<?php

/*
* minimiert css-Files
* Olaf Penschke (olape)
* Version 1.1
* 18.02.2017 : 20:03
*/

/*
Aufruf per .htaccess --> mincss.php muss im Root liegen - mod_rewrite muss verfgbar sein

<IfModule mod_rewrite.c>
RewriteEngine On
RewriteBase /
RewriteRule ^(.*).css$ /mincss.php?css=$1.css [L]
</IfModule>

*/

if(!empty($_GET['css'])) {
	$cssfile = $_GET['css'];

	$csstmp = file_get_contents($cssfile);
	$csstmp = preg_replace('#/\*[^*]*\*+([^/][^*]*\*+)*/#', ' ', $csstmp);	// Kommentare entfernen
	$csstmp = str_replace(array("\r\n", "\r", "\n", "\t"), ' ', $csstmp);	// Tabs, Zeilenumbrche ... entfernen
	$csstmp = preg_replace('/\s\s+/', ' ', $csstmp);						// mehrere Leerzeichen reduzieren

	$csstmp = str_replace('{ ', '{', $csstmp);
	$csstmp = str_replace(' {', '{', $csstmp);
	$csstmp = str_replace('} ', '}', $csstmp);
	$csstmp = str_replace(' }', '}', $csstmp);

	$csstmp = str_replace('; ', ';', $csstmp);
	$csstmp = str_replace(' ;', ';', $csstmp);
	$csstmp = str_replace(', ', ',', $csstmp);
	$csstmp = str_replace(' ,', ',', $csstmp);

	$csstmp = str_replace(': ', ':', $csstmp);
	$csstmp = str_replace(' :', ':', $csstmp);

	$csstmp = str_replace(';}', '}', $csstmp);

	$csstmp = trim($csstmp);

	header('content-type: text/css; charset: UTF-8');						// MIME Type setzen

	$etag = md5($csstmp);													// Cachen fr dynamisch generierte CSS-Datei auf Clientseite per ETag (MD5)
	$maxAge = 14400;														// 4h
	header('ETag: '.$etag);
	header('Cache-Control: must-revalidate');
	header('Cache-Control: max-age=' . $maxAge . ', true');
	if(isset($_SERVER['HTTP_IF_NONE_MATCH']) && trim($_SERVER['HTTP_IF_NONE_MATCH']) == $etag) {
		header('HTTP/1.1 304 Not Modified');
		die();
	}

	print $csstmp;
}